Bug 772358 - pdwtags 1.9 cannot read files produced by gcc 4.7
Summary: pdwtags 1.9 cannot read files produced by gcc 4.7
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: dwarves
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Arnaldo Carvalho de Melo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-01-06 22:54 UTC by Eric Blake
Modified: 2012-07-03 15:56 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2012-07-03 15:55:20 UTC


Attachments (Terms of Use)
compiled on F16 (5.61 KB, application/octet-stream)
2012-01-06 23:02 UTC, Eric Blake
no flags Details
compiled on F17 (8.17 KB, application/octet-stream)
2012-01-06 23:39 UTC, Eric Blake
no flags Details

Description Eric Blake 2012-01-06 22:54:42 UTC
Description of problem:
libvirt uses pdwtags as part of 'make check' to ensure binary compatible layouts between versions.  However, on rawhide, this check fails (see bug 613600), since gcc is new enough to be outputting additional DWARF debugging elements that pdwtags has not yet learned to parse.

Version-Release number of selected component (if applicable):
dwarves-1.9-1.fc16.x86_64
gcc-4.7.0-0.4.fc17.x86_64
binutils-2.22-1.fc17.x86_64

How reproducible:
100%

Steps to Reproduce:
1. I've gone ahead and pre-compiled the same file on both F16 (gcc-4.6.2-1.fc16.x86_64 and binutils-2.21.53.0.1-6.fc16.x86_64) and rawhide (versions shown above), and attached the two object files (the compiled file is libvirt_net_rpc_la-virkeepaliveprotocol.o from libvirt.git); the steps below use the same version of pdwtags, so the only difference is in the gcc and binutils versions used to make the .o file
2. pdwtags --verbose f16.o | wc
3. pdwtags --verbose f17.o
  
Actual results:
2.     280    1006    5310
3. die__process_function: DW_TAG_INVALID (0x4109) @ <0x58c> not handled!

Expected results:
Both .o files should be decoded, with only minor variations in output according to whatever minor variations were present in the gcc code generation.

Additional info:
I also reproduced this on the i686 versions of the packages.

Comment 1 Eric Blake 2012-01-06 23:02:54 UTC
Created attachment 551301 [details]
compiled on F16

Comment 2 Eric Blake 2012-01-06 23:39:42 UTC
Created attachment 551307 [details]
compiled on F17

Comment 3 Aravind vijayan 2012-01-16 13:03:12 UTC

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 4 Fedora Update System 2012-05-31 17:48:11 UTC
dwarves-1.10-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/dwarves-1.10-1.fc17

Comment 5 Fedora Update System 2012-05-31 18:08:40 UTC
dwarves-1.10-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/dwarves-1.10-1.fc16

Comment 6 Fedora Update System 2012-05-31 18:56:42 UTC
dwarves-1.10-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/dwarves-1.10-1.fc15

Comment 7 Fedora Update System 2012-06-01 16:49:09 UTC
Package dwarves-1.10-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing dwarves-1.10-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-8660/dwarves-1.10-1.fc17
then log in and leave karma (feedback).

Comment 8 Fedora Update System 2012-07-03 15:55:20 UTC
dwarves-1.10-1.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2012-07-03 15:56:23 UTC
dwarves-1.10-1.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.